// file NumberList.cpp

#include <iostream>
using namespace std;

#include "NumberList.h"

NumberList::NumberList() {
    
    head = nullptr;
}

bool NumberList::isEmpty() {
    
    return (head==nullptr);
}

NumberList::~NumberList() {
    
    ListNode *p;
    while (!isEmpty()) {
        // delete the first node
        p = head;
        head = head->next;
        delete p;
    }
}

void NumberList::appendNode(double num) {
    
    ListNode *newNode;
    newNode = new ListNode;
    newNode->value = num;
    newNode->next = nullptr;
    
    if (head==nullptr)
        head = newNode;
    
    else {
        ListNode *p = head;
        while (p->next!=nullptr) {
            p = p->next;
        }
        // now p points to the last node
        p->next = newNode;
    }
    
}

void NumberList::displayList() {
    
    ListNode *p = head;
    while (p!=nullptr) {
        cout << p->value  << "  ";
        p = p->next;
    }
    cout << endl;
    
}

void NumberList::deleteNode(double num) {
    
    ListNode *p = head;      // to traverse the list
    ListNode *n = nullptr;   // trailing node pointer
    
    // skip nodes not equal to num, stop at last
    while (p && p->value!=num) {
        n = p;        // save it!
        p = p->next;  // advance it
    }
    
    // p not null: num is found, set links + delete
    if (p) {
        if (n==nullptr) {   // p points to the first elem.
            head = p->next;
            delete p;
        } else {            // n points to the predecessor
            n->next = p->next;
            delete p;
        }
    }
}

void NumberList::insertBefore(double num, double target) {
    
    //make new node
    ListNode *newNode = new ListNode;
    newNode->value = num;

    //set up pointers
    ListNode *p = head;
    ListNode *n = nullptr;
    
    //advance pointers through list to insertion point
    while (p && p->value != target) {
        n = p;
        p = p->next;
    }
    
    //change pointers to include new node
    if (n==nullptr) {
        head = newNode;
        newNode->next = p;
    } else {
        n->next=newNode;
        newNode->next = p;
    }

}




